// GActiveObject.h: interface for the GActiveObject class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_GACTIVEOBJECT_H__9C105360_5EE8_4EBC_8A6B_90C71F4DA2DC__INCLUDED_)
#define AFX_GACTIVEOBJECT_H__9C105360_5EE8_4EBC_8A6B_90C71F4DA2DC__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "GObject.h"

class GAI;
class H3DModel;

class GActiveObject : public GObject  
{
public:

	virtual void Render();
	virtual void DoEvent();
	
	GActiveObject(GEngine *engine, H3DModel *model3D);
	virtual ~GActiveObject();

	// inteligence pohybu (muze byt i clovek) - je nase vlasti - pro kazdy objekt unikatni kopie
	GAI   *m_ai;
	
  // nastavi AI
  virtual void SetAI(GAI *ai);
  
	// ukazatel na model, ktery se bude kreslit - propujceny ukazatel
	H3DModel *m_3Dmodel;

	// ovlada umela inteligence
	bool   m_up;
	bool   m_down;
	bool   m_left;
	bool   m_right;
	bool   m_action;

	// souradnice
	CVector3 m_position;

	// zmena pohybu
	CVector3 m_moveing;

	// smer, kterym by jsme chteli letet
	CVector3 m_req_movement;

	// rotace - natoceni objektu
	CVector3 m_rotation;

	// koeficient pri prepoctu m_moveing pomoci m_req_movement
	float    m_acceleration; 

	// rychlost objektu
	float    m_speed;

	// tady by se taky meli pripsat veci jako rozmery a hmotnost pro ucely kolize

   // volano, pokud vznikla kolize s jinym GActiveObject
   // vraci true, pokud je tvrdym objektem a je treba odstranit kolizni stav
   // false, pokud si objekt mysli, ze kolizni stav je OK
   virtual bool Hitted(GActiveObject *object);

   // rozmary objektu
	CVector3 m_size;
	// hmotnost objektu - nesmi byt o, protoze se sni deli
	float    m_veight;   
	// stare udaje (ukladaji se pred zmenou souradnic)
	struct st_old{
		CVector3 m_position; // stara pozice
	} m_old;
};

#endif // !defined(AFX_GACTIVEOBJECT_H__9C105360_5EE8_4EBC_8A6B_90C71F4DA2DC__INCLUDED_)
