// GBackGround.cpp: implementation of the GBackGround class.
//
//////////////////////////////////////////////////////////////////////

#include "ph.h"
#include "GBackGround.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

GBackGround::GBackGround(GEngine *engine) :
GObject(engine)
{
	m_type = GOBJ_BACK_GROUND;
	
   m_start_time = 1000;
   m_bAsync     = FALSE;
   SetPeriod(1000, 0, FALSE);

	m_texture = htexture.GetTexture("pozadi.jpg");
}

GBackGround::~GBackGround()
{
   htexture.RemoveTexture(m_texture);
}

#define BACKGROUND_X  28
#define BACKGROUND_Y  21
#define BACKGROUND_Z -50

void GBackGround::Render()
{
	// Zatek prostorov matice
	glPushMatrix();

	glEnable(GL_TEXTURE_2D);


	// Nastaveni textury
	htexture.SetTexture(m_texture);

	// otexturovany obdelnik
	glBegin(GL_POLYGON);
		glTexCoord2f(0.0f, 1.0f); glVertex3f( -BACKGROUND_X,  BACKGROUND_Y, BACKGROUND_Z);
		glTexCoord2f(1.0f, 1.0f); glVertex3f(  BACKGROUND_X,  BACKGROUND_Y, BACKGROUND_Z);
		glTexCoord2f(1.0f, 0.0f); glVertex3f(  BACKGROUND_X, -BACKGROUND_Y, BACKGROUND_Z);
		glTexCoord2f(0.0f, 0.0f); glVertex3f( -BACKGROUND_X, -BACKGROUND_Y, BACKGROUND_Z);
	glEnd();

/*	
 // obarveny obdelnik
  glBegin(GL_QUADS);				
		glTexCoord2f(0.0f, 1.0f); glVertex3f( -BACKGROUND_X,  BACKGROUND_Y, BACKGROUND_Z);
		glTexCoord2f(1.0f, 1.0f); glVertex3f(  BACKGROUND_X,  BACKGROUND_Y, BACKGROUND_Z);
		glTexCoord2f(1.0f, 0.0f); glVertex3f(  BACKGROUND_X, -BACKGROUND_Y, BACKGROUND_Z);
		glTexCoord2f(0.0f, 0.0f); glVertex3f( -BACKGROUND_X, -BACKGROUND_Y, BACKGROUND_Z);
	glEnd();
*/
	// obnoveni stare matice
	glPopMatrix();
}
