// GShoot.cpp: implementation of the GShoot class.
//
//////////////////////////////////////////////////////////////////////

#include "ph.h"
#include "GShoot.h"
#include "GSpaceShip.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

GShoot::GShoot(GEngine *engine, H3DModel *model3D, GObject *owner) 
 : GActiveObject(engine, model3D)
{

	m_type = GOBJ_SHOOT;
	
	// nastaveni casovace
   m_start_time = 15;
   m_bAsync     = FALSE;
   SetPeriod(15, 0, FALSE);

	// nastaveni strely
	m_acceleration = 0.1f;
	m_speed = 1.0f;
	m_owner = owner;

	// velikost strely
	m_size.x = 1;
	m_size.y = 1;
	m_size.z = 5;	
}

GShoot::~GShoot()
{

}

/////////////////////////////////////////////////////////////////////////////////////////////

void GShoot::DoEvent()
{
	GActiveObject::DoEvent();

	// pokud strela opusti obrazovku, znicime ji
	if (abs((int)m_position.x) > LIMIT_SHOOT_X) WantBeDeleted();
}

/////////////////////////////////////////////////////////////////////////////////////////////

bool GShoot::Hitted(GActiveObject *object)
{
   if (IS_SHIP(object) && object != m_owner) {
   	((GSpaceShip*)object)->LostLives(5);
      WantBeDeleted();
	}
	
	return false; // strely jsou zatim neodstrkavaji - ale staci jen zmenit
}
