// GView.cpp: implementation of the GView class.
//
//////////////////////////////////////////////////////////////////////

#include "ph.h"
#include "GView.h"
#include "GEngine.h"
#include "GObject.h"
#include "GSpaceShip.h"
#include "H3DModel.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

GView::GView()
{
	m_camera_Z = 0;
}

GView::~GView()
{

}

void GView::Render()
{
	// Reset pohledu
	glLoadIdentity();			  	    

	// nastaveni pohledu "kamery"
	gluLookAt(0, 0, m_camera_Z, 0, 0, m_camera_Z-200, 0, 1.0, 0);

	// jednoduche zobrazeni vseho
	GObject **o =  &m_engine->m_object[0];
	for (int i = 0; i < m_engine->m_objects; i++, o++)
		if (*o != NULL) (*o)->Render();

//	m_engine->m_object[i]->Render();

	// zobazeni zivotu lodicek
	int livesR = ((GSpaceShip*)m_engine->m_object[0])->m_lives;
	int livesL = ((GSpaceShip*)m_engine->m_object[1])->m_lives;

	// Prava strana
	// Zatek prostorov matice
	glPushMatrix();
	// posunuti
//	
	glTranslated(3+((100-livesR)/5.01), 15.6, -40); 
	// kreslime model
	m_engine->m_3Dmodel[4]->Render();
	// obnoveni stare matice
	glPopMatrix();

	// Leva strana
	// Zatek prostorov matice
	glPushMatrix();
	// posunuti
	glTranslated(-3-((100-livesL)/5.01), 15.6, -40); 
	// kreslime model
	m_engine->m_3Dmodel[5]->Render();
	// obnoveni stare matice
	glPopMatrix();
}

bool GView::Init(GEngine *engine)
{
	m_engine = engine;
	return true;
}

void GView::Move()
{

}
