// MMenu.cpp: implementation of the MMenu class.
//
//////////////////////////////////////////////////////////////////////

#include "ph.h"
#include "MMenu.h"
#include "GRun.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

// statika inicializace
int MMenu::m_control_L = 1;
int MMenu::m_control_R = 0;


MMenu::MMenu(GRun *run)
{
	m_run = run;
	
   m_back_ground = htexture.GetTexture("menu.jpg");
   m_controls[0] = htexture.GetTexture("menu1.bmp");
   m_controls[1] = htexture.GetTexture("menu2.bmp");
   m_controls[2] = htexture.GetTexture("menu3.bmp");
}

MMenu::~MMenu()
{
   htexture.RemoveTexture(m_back_ground);
   htexture.RemoveTexture(m_controls[0]);
   htexture.RemoveTexture(m_controls[1]);
   htexture.RemoveTexture(m_controls[2]);
}

// zobrazi menu (aktualni stav)
void MMenu::Render()
{
	glLoadIdentity();
	glTranslatef(0.0f, 0.0f, -2.2f);

	// Nastaveni textury pozadi
	htexture.SetTexture(m_back_ground);
 	// otexturovany obdelnik (podklad)
	glBegin(GL_QUADS);
		glTexCoord2f(0.0f, 1.0f); glVertex3f( -1.1f,   1.0f, 0.0f);
		glTexCoord2f(1.0f, 1.0f); glVertex3f(  1.1f,   1.0f, 0.0f);
		glTexCoord2f(1.0f, 0.0f); glVertex3f(  1.1f,  -1.0f, 0.0f);
		glTexCoord2f(0.0f, 0.0f); glVertex3f( -1.1f,  -1.0f, 0.0f);
	glEnd();
  
	// Nastaveni textury levy hrac
	htexture.SetTexture(m_controls[m_control_L]);
 	// otexturovany obdelnik (podklad)
	glBegin(GL_QUADS);
		glTexCoord2f(0.0f, 1.0f); glVertex3f(  -0.66f, -0.2f, 0.1f);
		glTexCoord2f(1.0f, 1.0f); glVertex3f(  -0.26f, -0.2f, 0.1f);
		glTexCoord2f(1.0f, 0.0f); glVertex3f(  -0.26f, -0.4f, 0.1f);
		glTexCoord2f(0.0f, 0.0f); glVertex3f(  -0.66f, -0.4f, 0.1f);
	glEnd();

	// Nastaveni textury pravy hrac
	htexture.SetTexture(m_controls[m_control_R]);
 	// otexturovany obdelnik (podklad)
	glBegin(GL_QUADS);
		glTexCoord2f(0.0f, 1.0f); glVertex3f(  0.26f, -0.2f, 0.1f);
		glTexCoord2f(1.0f, 1.0f); glVertex3f(  0.66f, -0.2f, 0.1f);
		glTexCoord2f(1.0f, 0.0f); glVertex3f(  0.66f, -0.4f, 0.1f);
		glTexCoord2f(0.0f, 0.0f); glVertex3f(  0.26f, -0.4f, 0.1f);
	glEnd();		

}

// reaguje na stisk klavesy
void MMenu::KeyDown(Uint8 key)
{
	switch (key) {
	case SDLK_o:
	   if (++m_control_L > 2) m_control_L = 0;
		break;
	case SDLK_p:
	   if (++m_control_R > 2) m_control_R = 0;
		break;
	case SDLK_ESCAPE:
		m_run->ExitProgram();
		break;
	case SDLK_RETURN:
		if (m_control_L != m_control_R) // aby nebylo stejne ovladanni pro oba
			m_run->StartGame(m_control_L, m_control_R);
		break; 
	};
}

